local L = LibStub("AceLocale-3.0"):GetLocale("ProximoGrid", true)
ProximoGrid = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "AceHook-2.1", "FuBarPlugin-2.0");
local media = LibStub("LibSharedMedia-3.0");
media:Register("sound", "Levelup", [[Sound\Spells\LevelUp.wav]]);
media:Register("sound", "GnomeExploration", [[Sound\interface\GnomeExploration.wav]]);
media:Register("sound", "RaidWarning", [[Sound\interface\RaidWarning.wav]]);

media:Register("statusbar", "Gradient", "Interface\\Addons\\ProximoGrid\\gradient32x32");
--seterrorhandler(function() ProximoGrid:Debug(debugstack());end)
local waterfall = AceLibrary:HasInstance("Waterfall-1.0") and AceLibrary("Waterfall-1.0");
local BabbleClass = LibStub:GetLibrary("LibBabble-Class-3.0")
local BC = BabbleClass:GetLookupTable()



ProximoGrid:RegisterDB("ProximoGridDB", "ProximoGridDBPC");


ProximoGrid.profileDefault = {
	showMinimapIcon = true,
	frame = {
		padding = 2,
		spacing = 2,
		anchor = "CENTER",
		groupAnchor = "TOPLEFT",
		scale = 1,
		clampToScreen = true,
		background = {0, 0, 0, 1},
		border = {1, 1, 1, 1},
		framesPerRow = 5,
		rows = 1,
		lock = false,
		positionX = 0,
		positionY = 0,
		horizontalGroups = true,
		showPetFrame = false,
		useInBG = false,
		dynamicHeight = true,
		borderTexture = "Blizzard Tooltip"
	},
	unitFrame = {
		width = 41,
		height = 34,
		frameTexture = "GRADIENT",
		font = "Friz Quadrata TT",
		fontSize = 8.0,
		textLength = 5,
		cornerSize = 5,
		texture = "Gradient",
		invertBarColor = false,
		barColor = {1, 1, 1, 0.8},
		textOrientation = "VERTICAL",
		frameOrientation = "VERTICAL",
	},
	announcement = {
		enable = false,
		enableSound = true,
		enableBG = false,
		color = {1, 0, 0, 1}
	},
	macros = {
		["1"] = {
			actionType = "target",
			action = ""
		},	
		["2"] = {
			actionType = "none",
			action = ""
		},
		["3"] = {
			actionType = "none",
			action = ""
		},
		["4"] = {
			actionType = "none",
			action = ""
		},
		["5"] = {
			actionType = "none",
			action = ""
		},
	},
	status = {},
	indicators = {},
	announcements = {
		[L["Chat"]] = {
			["announcementDeath"] = true,
			["announcementNewOpponent"] = true,
			["announcementLowHealth"] = true
		},
		[L["Raid Warning"]] = {},
		[L["Party"]] = {},
		[L["Battleground"]] = {},
		[L["Raid"]] = {},
		[L["Scrolling Combat Text"]] = {},
		[L["Sound Warning"]] = {
			["announcementDeath"] = true,
			["announcementNewOpponent"] = true,
			["announcementLowHealth"] = true
		}
	},
	announcementSettings = {},
	colors = {
		
		race = {
			[L["Human"]] = {1, 1, 0, 1},
			[L["Night Elf"]] = {0.5, 1, 0.5, 1},
			[L["Gnome"]] = {1, 1, 1, 1},
			[L["Dwarv"]] = {0.5, 0.5, 0.5, 1},
			[L["Draenei"]] = {0, 0, 1, 1},
			[L["Orcs"]] = {0, 0.5, 0, 1},
			[L["Tauren"]] = {0.5, 0.25, 0, 1},
			[L["Undead"]] = {0, 0, 0, 1},
			[L["Blood Elf"]] = {1, 0, 0, 1},
			[L["Troll"]] = {0, 0, 0.3, 1},
		},

		class = {
			[BC["Druid"]] = {RAID_CLASS_COLORS["DRUID"].r, RAID_CLASS_COLORS["DRUID"].g, RAID_CLASS_COLORS["DRUID"].b, 1},
			[BC["Hunter"]] = {RAID_CLASS_COLORS["HUNTER"].r, RAID_CLASS_COLORS["HUNTER"].g, RAID_CLASS_COLORS["HUNTER"].b, 1},
			[BC["Mage"]] = {RAID_CLASS_COLORS["MAGE"].r, RAID_CLASS_COLORS["MAGE"].g, RAID_CLASS_COLORS["MAGE"].b, 1},
			[BC["Paladin"]] = {RAID_CLASS_COLORS["PALADIN"].r, RAID_CLASS_COLORS["PALADIN"].g, RAID_CLASS_COLORS["PALADIN"].b, 1},
			[BC["Priest"]] = {RAID_CLASS_COLORS["PRIEST"].r, RAID_CLASS_COLORS["PRIEST"].g, RAID_CLASS_COLORS["PRIEST"].b, 1},
			[BC["Rogue"]] = {RAID_CLASS_COLORS["ROGUE"].r, RAID_CLASS_COLORS["ROGUE"].g, RAID_CLASS_COLORS["ROGUE"].b, 1},
			[BC["Shaman"]] = {RAID_CLASS_COLORS["SHAMAN"].r, RAID_CLASS_COLORS["SHAMAN"].g, RAID_CLASS_COLORS["SHAMAN"].b, 1},
			[BC["Warlock"]] = {RAID_CLASS_COLORS["WARLOCK"].r, RAID_CLASS_COLORS["WARLOCK"].g, RAID_CLASS_COLORS["WARLOCK"].b, 1},
			[BC["Warrior"]] = {RAID_CLASS_COLORS["WARRIOR"].r, RAID_CLASS_COLORS["WARRIOR"].g, RAID_CLASS_COLORS["WARRIOR"].b, 1},
			[BC["Deathknight"]] = {RAID_CLASS_COLORS["DEATHKNIGHT"].r, RAID_CLASS_COLORS["DEATHKNIGHT"].g, RAID_CLASS_COLORS["DEATHKNIGHT"].b, 1},
		},
		creatureType = {
			[L["Beast"]] = { 0.93725490196078, 0.75686274509804, 0.27843137254902, 1 },
			[L["Demon"]] = { 0.54509803921569, 0.25490196078431, 0.68627450980392, 1 },
			[L["Humanoid"]] = { 0.91764705882353, 0.67450980392157, 0.84705882352941, 1 },
		},
		powerType = {
			[L["MANA"]] = {0.1, 0.3, 1, 1},
			[L["ENERGY"]] = {1, 1, 0, 1},
			[L["RAGE"]] = {1, 0, 0, 1},
		},
		fallback = {
			[L["Unknown Unit"]] = { 0.5, 0.5, 0.5, 1 },
			[L["Unknown Pet"]] = { 0, 1, 0, 1 },
		}
	}
};
ProximoGrid:RegisterDefaults("profile", ProximoGrid.profileDefault);




ProximoGrid.options = {
	type = "group",
	handler = ProximoGrid,
	args = {
		["gui"] = {
			type = "execute",
			name = "gui",
			desc = L["Show the configuration GUI"],
			order = 106,
			func = function()
				ProximoGrid:OpenConfig()
			end
		},
		["test"] = {
			type = "execute",
			name = "test",
			desc = L["Show Test Frames"],
			order = 106,
			func = function()
				ProximoGrid:ShowTestFrames()
			end
		},
		["Status"] = {
			type = "group",
			name = L["Status"],
			desc = L["Setup the frame"],
			order = 120,
			args = {
			
				colors = {
					type = "group",
					name = "Colors",
					desc = "Color options for class and pets",
					args = {
						class = {
							type = "group",
							name = L["Class Colors"],
							desc = L["Colors of player classes."],
							args = {

							}
						},
						race = {
							type = "group",
							name = L["Race Colors"],
							desc = L["Colors of player races."],
							args = {

							}
						},
						creatureType = {
							type = "group",
							name = L["Creature Type Colors"],
							desc = L["Colors of pet types."],
							args = {

							}
						},
						powerType = {
							type = "group",
							name = L["Power Type Colors"],
							desc = L["Colors of different power types."],
							args = {

							}
						},
						fallback = {
							type = "group",
							name = L["Fallback colors"],
							desc = L["Colors of unknown units or pets."],
							args = {

							}
						},
					},
					order = 999
				}
			}
		},
		["Layout"] = {
			type = "group",
			name = L["Layout"],
			desc = L["Setup the frame"],
			order = 120,
			args = {

				borderColor = {
					type = 'color',
					name = L["Border color"],
					desc = L["Change the color of the frame's border"],
					get = function()
						local tmpColor = ProximoGrid.db.profile.frame.border;
						return tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4]
					end,
					set = function(r, g, b, a)
						local tmpColor = ProximoGrid.db.profile.frame.border;
						tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4] = r, g, b, a or 1
						ProximoGrid.Frame["MainFrame"]:SetBackdropBorderColor(tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4]);
					end,
					hasAlpha = true,
					order = 20
				},
				frameColor = {
					type = 'color',
					name = L["Frame background"],
					desc = L["Change the color of the frame's background."],
					get = function()
						local tmpColor = ProximoGrid.db.profile.frame.background;
						return tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4]
					end,
					set = function(r, g, b, a)
						local tmpColor = ProximoGrid.db.profile.frame.background;
						tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4] = r, g, b, a or 1
						ProximoGrid.Frame["MainFrame"]:SetBackdropColor(tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4]);
						ProximoGrid.Frame["MainFrame"].texture:SetGradientAlpha("VERTICAL", .1, .1, .1, 0, .2, .2, .2, tmpColor[4]*0.5)
					end,
					hasAlpha = true,
					order = 40
				},
				horizontalGroups = {
					type = "toggle",
					name = L["Horizontal Groups"],
					desc = L["Switch between horizontal/vertical groups."],
					get = function()
						return ProximoGrid.db.profile.frame.horizontalGroups;
					end,
					set = function(v)
						ProximoGrid.db.profile.frame.horizontalGroups = v;
						for i=1, ProximoGrid:GetRows()*ProximoGrid:GetColumns() do
							ProximoGrid.UnitFrame:UpdateUnitFrame(ProximoGrid.UnitFrames[i], i);
						end
						ProximoGrid:UpdateFrameSize();
					end,
					order = 60
				},
				showInBG = {
					type = "toggle",
					name = L["Enable in BGs"],
					desc = L["Enable ProximoGrid in Arathi Basin, Warsong Gulch and Strand of the Ancients."],
					get = function()
						return ProximoGrid.db.profile.frame.useInBG;
					end,
					set = function(v)
						ProximoGrid.db.profile.frame.useInBG = v;
						ProximoGrid:UpdateFrame();
					end,
					order = 80
				},
				--showPets = {
				--	type = "toggle",
				--	name = L["Show pets"],
				--	desc = L["Show pets."],
				--	get = function()
				--		return ProximoGrid.db.profile.frame.showPetFrame;
				--	end,
				--	set = function(v)
				--		ProximoGrid.db.profile.frame.showPetFrame = v;
				--		ProximoGrid:UpdateLayout();
				--		ProximoGrid:UpdateFrameSize();
				--		ProximoGrid:UpdateFramePosition();
				--		
				--	end,
				--	disabled = true,
				--	order = 100
				--
				--},
				frameLock = {
					type = "toggle",
					name = L["Frame lock"],
					desc = L["Locks/unlocks the grid for movement."],
					get = function()
						return ProximoGrid.db.profile.frame.lock;
					end,
					set = function(v)
						ProximoGrid.db.profile.frame.lock = v;
						ProximoGrid.Frame["MainFrame"]:EnableMouse(not (v));
						if (not ProximoGrid:inArenaZone() and (not ProximoGrid:inBGZone() or not ProximoGrid.db.profile.frame.useInBG) and ProximoGrid.db.profile.frame.lock) then
							ProximoGrid.Frame["MainFrame"]:Hide()	
						else
							ProximoGrid.Frame["MainFrame"]:Show()
						end
						
						ProximoGrid:UpdateFrame();
					end,
					order = 120
				},
				dynamicLayout = {
					type = "toggle",
					name = L["Dynamic layout"],
					desc = L["This will enable 5 frames in each row and then use one row in Arena, 2 rows in WSG and 3 rows in AB and EotS."],
					get = function()
						local returnValue = ProximoGrid.db.profile.frame.dynamicLayout;
						ProximoGrid.options.args.Layout.args.rows.disabled = (returnValue);
						return returnValue;
					end,
					set = function(v)
						ProximoGrid.db.profile.frame.dynamicLayout = v;
						ProximoGrid:UpdateLayout();
						ProximoGrid:UpdateFrame();
					end,
					order = 140
				
				},
				padding = {
					type = "range",
					name = L["Padding"],
					desc = L["Frame padding."],
					get = function()
						return ProximoGrid.db.profile.frame.padding;
					end,
					set = function(v)
						ProximoGrid.db.profile.frame.padding = v;
						ProximoGrid:UpdateFrameSize();
						ProximoGrid.UnitFrame:UpdateUnitFrame(ProximoGrid.UnitFrames[1], 1);
					end,
					min = 0,
					max = 13,
					step = 1,
					order = 160
				},
				spacing = {
					type = "range",
					name = L["Spacing"],
					desc = L["Frame spacing."],
					get = function()
						return ProximoGrid.db.profile.frame.spacing;
					end,
					set = function(v)
						ProximoGrid.db.profile.frame.spacing = v;
						for va, k in pairs(ProximoGrid.UnitFrames) do
							ProximoGrid.UnitFrame:UpdateUnitFrame(k, va);
						end
						ProximoGrid:UpdateFrameSize();
					end,
					min = 0,
					max = 13,
					step = 1,
					order = 180
				},
				scale = {
					type = "range",
					name = L["Scale"],
					desc = L["Frame scale."],
					get = function()
						return ProximoGrid.db.profile.frame.scale;
					end,
					set = function(v)
						ProximoGrid.db.profile.frame.scale = v;
						ProximoGrid:SaveFramePosition();
						ProximoGrid.Frame["MainFrame"]:SetScale(v);
						ProximoGrid:UpdateFramePosition();
					end,
					min = 0.5,
					max = 2,
					step = 0.1,
					order = 200
				},
				rows = {
					type = "range",
					name = L["Rows"],
					desc = L["The maximum rows that will be used."],
					get = function()
						return ProximoGrid.db.profile.frame.rows;
					end,
					set = function(v)
						ProximoGrid.db.profile.frame.rows = v;
						ProximoGrid:UpdateLayout();
						ProximoGrid:UpdateFrame();
					end,
					min = 1,
					max = 3,
					step = 1,
					order = 220
				},

				--framesInEachRow = {
				--	type = "range",
				--	name = L["Frames in each row"],
				--	desc = L["The maximum number of frames in each row."],
				--	get = function()
				--		return ProximoGrid.db.profile.frame.framesPerRow;
				--	end,
				--	set = function(v)
				--		ProximoGrid.db.profile.frame.framesPerRow = v;
				--		ProximoGrid:UpdateLayout();
				--		ProximoGrid:UpdateFrameSize();
				--		ProximoGrid:UpdateFramePosition();
				--	end,
				--	min = 1,
				--	max = 5,
				--	step = 1,
				--	order = 240
				--},
				advanced = {
					type = "group",
					name = L["Advanced"],
					desc = L["Advanced options."],
					args = {
						layoutAnchor = {
							type = "text",
							name = L["Layout Anchor"],
							desc = L["Sets where ProximoGrid is anchored relative to the screen."],
							get = function ()
								return ProximoGrid.db.profile.frame.anchor
							end,
							set = function (v)
								ProximoGrid.db.profile.frame.anchor = v
								ProximoGrid:SaveFramePosition();
								ProximoGrid:UpdateFramePosition();
							end,
							validate={["CENTER"] = L["CENTER"], ["LEFT"] = L["LEFT"], ["BOTTOM"] = L["BOTTOM"], ["RIGHT"] = L["RIGHT"], ["TOP"] = L["TOP"],
								["TOPLEFT"] = L["TOPLEFT"], ["BOTTOMLEFT"] = L["BOTTOMLEFT"], ["BOTTOMRIGHT"] = L["BOTTOMRIGHT"], ["TOPRIGHT"] = L["TOPRIGHT"],},
							order = 20,
						},
						groupAnchor = {
							type = "text",
							name = L["Group Anchor"],
							desc = L["Sets where groups are anchored relative to the layout frame."],
							get = function ()
								return ProximoGrid.db.profile.frame.groupAnchor
							end,
							set = function (v)
								ProximoGrid.db.profile.frame.groupAnchor = v
								for va, k in pairs(ProximoGrid.UnitFrames) do
									ProximoGrid.UnitFrame:UpdateUnitFrame(k, va);
								end
							end,
							validate={["TOPLEFT"] = L["TOPLEFT"], ["BOTTOMLEFT"] = L["BOTTOMLEFT"], ["BOTTOMRIGHT"] = L["BOTTOMRIGHT"], ["TOPRIGHT"] = L["TOPRIGHT"],},
							order = 40,
						},
						borderTexture = {
							type = "text",
							name = L["Border Texture"],
							desc = L["Choose the layout border texture."],
							validate = (media:List(media.MediaType.BORDER)),
							order = 60,
							get = function ()
								return ProximoGrid.db.profile.frame.borderTexture
							end,
							set = function (v)
								ProximoGrid.db.profile.frame.borderTexture = v
								ProximoGrid:UpdateFrameColor();
							end,
						},
						resetPosition = {
							type = "execute",
							name = L["Reset Frame Position"],
							desc = L["Resets the frame's position."],
							order = 106,
							func = function()
								ProximoGrid:ResetFramePosition()
							end,
							order = 80
						}
						
					}
				}
			}
		},
		announcements = {
			type = "group",
			name = L["Announcements"],
			desc = string.format(L["Options for %s."], L["Announcements"]),
			args = {
				enable = {
					type = "toggle",
					name = L["Enable Announcements"],
					desc = L["Toggle announcements"],
					get = function()
						local returnValue=ProximoGrid.db.profile.announcement.enable;
						ProximoGrid.options.args.announcements.args.enableBG.disabled = (not returnValue);
						ProximoGrid.options.args.announcements.args.enableSound.disabled = (not returnValue);
						return returnValue
					end,
					set = function(v)
						ProximoGrid.db.profile.announcement.enable = v;
						--ProximoGrid.options.args.announcements.args.enableBG:disabled = (not v);
						--ProximoGrid.options.args.announcements.args.enableSound:disabled = (not v);
					end
				},
				enableBG = {
					type = "toggle",
					name = L["Enable Announcements in BGs"],
					desc = L["Toggle if announcements should be used in BGs."],
					get = function()
						return ProximoGrid.db.profile.announcement.enableBG
					end,
					set = function(v)
						ProximoGrid.db.profile.announcement.enableBG = v;
					end
				},
				enableSound = {
					type = "toggle",
					name = L["Enable Sound Warning"],
					desc = L["Toggle sound."],
					get = function()
						return ProximoGrid.db.profile.announcement.enableSound
					end,
					set = function(v)
						ProximoGrid.db.profile.announcement.enableSound = v;
					end
				},
				moreSettings = {
					type = "group",
					name = L["More Settings"],
					desc = L["More settings for each announcement"];
					args = {};
				}
			}
		},
		macros = {
			type = "group",
			name = L["Macros"],
			desc = L["Change what will happen when you click on an unit frame."],
			args = {
				
			}
		
		}
	}
}

--Fubar
ProximoGrid.name                   = "ProximoGrid"
ProximoGrid.hasIcon                = true
ProximoGrid.defaultMinimapPosition = 240
ProximoGrid.cannotDetachTooltip    = true
ProximoGrid.independentProfile     = true
ProximoGrid.defaultPosition        = "RIGHT"
ProximoGrid.hideWithoutStandby     = true
ProximoGrid.OnMenuRequest          = ProximoGrid.options

--UI Variables
ProximoGrid.Frame = {};
ProximoGrid.UnitFrames = {};
ProximoGrid.UnitFrame = {};
ProximoGrid.RegisteredStatus = {};
ProximoGrid.RegisteredAnnouncement = {};
ProximoGrid.Status = {};
ProximoGrid.Indicators = {};
ProximoGrid.RegistredEvents = {};
ProximoGrid.RegistredEventsCounter = {};
ProximoGrid.FirstTime = false;
ProximoGrid.RowCache = 0;
ProximoGrid.arenaSize = 2;
ProximoGrid.location = "Outside";

ProximoGrid.raceIcons = {
  ["Human"]   =   { 0/8, 1/8, 0/4, 1/4 },
  ["Dwarf"]   =   { 1/8, 2/8, 0/4, 1/4 },
  ["Gnome"]   =   { 2/8, 3/8, 0/4, 1/4 },
  ["Night Elf"]  = { 3/8, 4/8, 0/4, 1/4 },
  ["Draenei"]   = { 4/8, 5/8, 0/4, 1/4 },
  ["Tauren"]    = { 0/8, 1/8, 1/4, 2/4 },
  ["Undead"]   = { 1/8, 2/8, 1/4, 2/4 },
  ["Troll"]   =   { 2/8, 3/8, 1/4, 2/4 },
  ["Orc"]     =   { 3/8, 4/8, 1/4, 2/4 },
  ["Blood Elf"]  = { 4/8, 5/8, 1/4, 2/4 },
};

ProximoGrid.announcementSounds = {
	[1] = "LEVELUP",
	[2] = "GnomeExploration",
	[3] = "RaidWarning"
}

ProximoGrid.StatusCache = {};
ProximoGrid.Opponents = {};
ProximoGrid.UnitCheckList = {
	["1"] = "target",
	["2"] = "party2target",
	["3"] = "party3target",
	["4"] = "party4target",
	["5"] = "party5target",
	["6"] = "focus",
	["7"] = "pettarget",
	["8"] = "party2pettarget",
	["9"] = "party3pettarget",
	["10"] = "party4pettarget",
	["11"] = "party5pettarget",
	["12"] = "mouseover"
}

--Opens the GUI
function ProximoGrid:OpenConfig()
	if (waterfall:IsOpen("ProximoGrid")) then
		waterfall:Close("ProximoGrid");
	else
		waterfall:Open("ProximoGrid");
	end
end

--Starts the addon
function ProximoGrid:OnInitialize()
	local indiOptions = ProximoGrid.options.args.Frame.args;
	for name, data in pairs(ProximoGrid.db.profile.indicators) do
		if (data["name"]~=nil) then
			indiOptions[name] = {
				type = "group",
				name = data["name"],
				desc = string.format(L["Options for %s indicator"], data["name"]);
				args = {}
			}
		end
	end
	--Inits indicators
	for indicatorName, indicatorData in pairs(ProximoGrid.Indicators) do
		for optionName, optionData in pairs (indicatorData.module.options) do
			indiOptions[optionName] = optionData;
		end
		indicatorData.module:OnInit();
	end
	for name, status in pairs(ProximoGrid.profileDefault.status) do
		getglobal(status["name"]):OnInit()
	end
	
	local mouseButtons = {
		[L["Left Mouse Button"]] = "1",
		[L["Right Mouse Button"]] = "2",
		[L["Middle Mouse Button"]] = "3",
		[L["Mouse Button 4"]] = "4",
		[L["Mouse Button 5"]] = "5"
	}
	local actionTypes = {
		["macro"] = L["Macro Name"],
		["spell"] = L["Spell"],
		["target"] = L["Target"],
		["macroText"] = L["Macro Text"],
		["none"] = L["None"],
	}
	local macroOptions = ProximoGrid.options.args.macros.args;

	
	for mouseButton, number in pairs(mouseButtons) do
		macroOptions[mouseButton] = {
			type = "group",
			name = mouseButton,
			desc = mouseButton,
			order = number*5,
			args = {

				actionTyp = {
					type = "text",
					name = L["Action Type"],
					desc = L["Chose what kind of action you want for the curent mouse button."],
					order = 10,
					usage = "",
					get = function ()
						local tmpString = ProximoGrid.db.profile.macros[number].actionType;
						return tmpString;
					end,
					set = function (v)
						ProximoGrid.db.profile.macros[number].actionType = v;
						if (v == "target" or v == "none") then
							macroOptions[mouseButton].args.action.hidden = true;
						else
							macroOptions[mouseButton].args.action.hidden = false;
						end
						macroOptions[mouseButton].args.action.name = actionTypes[v]..".";
						waterfall:Refresh("ProximoGrid");
						ProximoGrid:UpdateFrameAttributes()
					end,
					validate = actionTypes,
				},
				action = {
					type = "text",
					name = L["Action"],
					desc = L["Action."],
					order = 20,
					usage = "",
					--disabled = true,
					get = function()
						local tmpString = ProximoGrid.db.profile.macros[number].actionType;
						--macroOptions[mouseButton].args.action.disabled = (tmpString=="target" or tmpString=="none");
						return ProximoGrid.db.profile.macros[number].action;
					end,
					set = function(v)
						ProximoGrid.db.profile.macros[number].action = v;
						ProximoGrid:UpdateFrameAttributes()
					end,
				},
			}
		}
		local tmpString = ProximoGrid.db.profile.macros[number].actionType;
		if (tmpString == "target" or tmpString == "none") then
			macroOptions[mouseButton].args.action.hidden = true;
		else
			macroOptions[mouseButton].args.action.hidden = false;
		end
		macroOptions[mouseButton].args.action.name = actionTypes[tmpString];
	end
	

	
	--Setups the color options
	local colorOptions = ProximoGrid.options.args.Status.args.colors.args;
	for group, colors in pairs(ProximoGrid.db.profile.colors) do
		for type, color in pairs (colors) do
			colorOptions[group].args[type] = {
				type = "color",
				name = type,
				desc = "The color of "..type,
				get = function()
					local tmpColor = ProximoGrid.db.profile.colors[group][type];
					return tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4]
				end,
				set = function(r, g, b, a)
					local tmpColor = ProximoGrid.db.profile.colors[group][type];
					tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4] = r, g, b, a or 1
				end,
				hasAlpha = false,
			};
		end
	end
	
	--Main frame
	local f = CreateFrame("Frame",nil,UIParent);
	f:EnableMouse(not (self.db.profile.frame.lock));
	f:SetMovable(true)
	f:SetClampedToScreen(self.db.profile.frame.clampToScreen)
	f:SetScript("OnMouseUp", function () self:StopMoveFrame() end)
	f:SetScript("OnHide", function () self:StopMoveFrame() end)
	f:SetScript("OnMouseDown", function () self:StartMoveFrame() end)
	f:SetFrameStrata("LOW")
	-- create background
	f:SetBackdrop({
		bgFile = "Interface\\ChatFrame\\ChatFrameBackground", tile = true, tileSize = 16,
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16,
		insets = {left = 4, right = 4, top = 4, bottom = 4},
	})
	f:SetFrameLevel(3)
	-- create bg texture
	f.texture = f:CreateTexture(nil, "BORDER")
	f.texture:SetTexture("Interface\\ChatFrame\\ChatFrameBackground")
	f.texture:SetPoint("TOPLEFT", f, "TOPLEFT", 4, -4)
	f.texture:SetPoint("BOTTOMRIGHT", f, "BOTTOMRIGHT", -4, 4)
	f.texture:SetBlendMode("ADD")
	local tmpColor = ProximoGrid.db.profile.frame.background;
	f.texture:SetGradientAlpha("VERTICAL", .1, .1, .1, 0, .2, .2, .2, tmpColor[4]*0.5)
	f:SetFrameStrata("BACKGROUND");
	f:Show();
	self.Frame["MainFrame"] = f;
	ProximoGrid:UpdateFrameSize();
	ProximoGrid:UpdateFrameColor();
	--Options
	ProximoGrid:RegisterChatCommand("/ProximoGrid", "/pg", ProximoGrid.options)
	local faction = UnitFactionGroup("player");
	if (faction == "Alliance") then
		ProximoGrid.faction = 1
	else
		ProximoGrid.faction = 0
	end
	--GUI options
	ProximoGrid.UnitFrame:CreatUnitFrames();
	f:SetScale(ProximoGrid.db.profile.frame.scale);
	
	--self:SetIcon("Interface\\AddOns\\ProximoGrid\icon");
	self:SetText("ProximoGrid");
	self.OnMenuRequest = self.options;
	if (self.db.profile.showMinimapIcon) then
		self:Show();
	else
		self:Hide();
	end
	self:Hook(ProximoGrid, "Show", function() ProximoGrid.db.profile.showMinimapIcon = true; ProximoGrid.hooks[ProximoGrid]["Show"](ProximoGrid); end);
	self:Hook(ProximoGrid, "Hide", function() ProximoGrid.db.profile.showMinimapIcon = false; ProximoGrid.hooks[ProximoGrid]["Hide"](ProximoGrid); end);
	waterfall:Register("ProximoGrid", "aceOptions", ProximoGrid.options, "title", "ProximoGrid Configuration")

	self.OnMenuRequest.args.hide.guiName = L["Hide minimap icon"];
	self.OnMenuRequest.args.hide.desc = L["Hide minimap icon"];
	
end

function ProximoGrid:UpdateFrameColor()
	local texture = media:Fetch(media.MediaType.BORDER, ProximoGrid.db.profile.frame.borderTexture)
	local backdrop = ProximoGrid.Frame["MainFrame"]:GetBackdrop()
	backdrop.edgeFile = texture
	ProximoGrid.Frame["MainFrame"]:SetBackdrop(backdrop)
	local tmpColor = ProximoGrid.db.profile.frame.background
	ProximoGrid.Frame["MainFrame"]:SetBackdropColor(tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4]);
	tmpColor = ProximoGrid.db.profile.frame.border
	ProximoGrid.Frame["MainFrame"]:SetBackdropBorderColor(tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4]);
end

--Fubar onclick
function ProximoGrid:OnClick()
	ProximoGrid:OpenConfig();
end

function ProximoGrid:ShowTestFrames()
	if (not (ProximoGrid:inArenaZone() or ProximoGrid:inBGZone())) then
		if(ProximoGrid.UnitFrames[1]:IsShown()) then
			for number, uf in pairs(ProximoGrid.UnitFrames) do
				uf:Hide();
			end
			if (ProximoGrid.db.profile.frame.lock) then
				ProximoGrid.Frame["MainFrame"]:Hide();
			end
		else
			if (ProximoGrid.db.profile.frame.lock) then
				ProximoGrid.Frame["MainFrame"]:Show();
			end
			local testArray = {
				[1] = {
					hp = 0;
				},
				[2] = {
					hp = 25;
				},
				[3] = {
					hp = 50;
				},
				[4] = {
					hp = 75;
				},
				[5] = {
					hp = 100;
				}
			}
			for number, uf in pairs(ProximoGrid.UnitFrames) do
				if (number > ProximoGrid:GetRows() * ProximoGrid:GetColumns()) then
					uf:Hide();
				else
					uf:Show();
					for name, data in pairs(ProximoGrid.db.profile.indicators) do
						ProximoGrid:UpdateIndicator(name, number, status)
					end
					if (testArray[number] ~= nil) then
						uf.Bar:SetValue(testArray[number].hp);
					end
				end
			end
			
		end
	end
end

--Returns unit frame rows
function ProximoGrid:GetRows()
	local rows
	--If the dynamic frame size is enabled
	if (ProximoGrid.db.profile.frame.dynamicLayout) then
		if (ProximoGrid:inArenaZone()) then
			rows = 1;
		elseif (ProximoGrid:inBGZone()) then
			if (GetRealZoneText() == L["Warsong Gulch"]) then
				rows = 2
			elseif (GetRealZoneText() == L["Arathi Basin"]) then
				rows = 3
			elseif (GetRealZoneText() == L["Eye of the Storm"]) then
				rows = 3
			elseif (GetRealZoneText() == L["Alterac Valley"]) then
				rows = 0
			elseif (GetRealZoneText() == L["Strand of the Ancients"]) then
				rows = 3
			else
				rows = 3;
			end
		else 
			rows = 1
		end
	else
		rows = ProximoGrid.db.profile.frame.rows;
	end
	if (ProximoGrid.db.profile.frame.showPetFrame) then
		rows = rows*2;
	end
	if (ProximoGrid.RowCache ~= rows) then
		ProximoGrid.RowCache = rows;
		ProximoGrid:UpdateFrameSize();
	end
	return rows;
end

--Returns unit frame columns, atm always 5.
function ProximoGrid:GetColumns()
	local columns;
	if (ProximoGrid.db.profile.frame.dynamicLayout) then
		columns = 5;
	else
		columns = ProximoGrid.db.profile.frame.framesPerRow;
	end
	return columns;
end

--Sets the main frame's position
function ProximoGrid:UpdateFramePosition()
	local f = self.Frame["MainFrame"];
	f:ClearAllPoints();
	local anchor = ProximoGrid.db.profile.frame.anchor;
	local UIScale = UIParent:GetEffectiveScale();
	local MFScale = f:GetEffectiveScale();
	local MFWidth = f:GetWidth();
	local MFWidth = f:GetHeight();
	f:SetPoint(anchor, UIParent, anchor, self.db.profile.frame.positionX/MFScale, self.db.profile.frame.positionY/MFScale);	
end

--Updates the main frame's size
function ProximoGrid:UpdateFrameSize()
	local f = self.Frame["MainFrame"];
	local borderWidth = 5;
	if (ProximoGrid.db.profile.frame.horizontalGroups) then
		f:SetWidth(borderWidth*2+ProximoGrid.db.profile.frame.padding*2+(ProximoGrid.db.profile.unitFrame.width+ProximoGrid.db.profile.frame.spacing)*ProximoGrid:GetColumns()-ProximoGrid.db.profile.frame.spacing);
		f:SetHeight(borderWidth*2+ProximoGrid.db.profile.frame.padding*2+(ProximoGrid.db.profile.unitFrame.height+ProximoGrid.db.profile.frame.spacing)*ProximoGrid:GetRows()-ProximoGrid.db.profile.frame.spacing);
	else
		f:SetWidth(borderWidth*2+ProximoGrid.db.profile.frame.padding*2+(ProximoGrid.db.profile.unitFrame.width+ProximoGrid.db.profile.frame.spacing)*ProximoGrid:GetRows()-ProximoGrid.db.profile.frame.spacing);
		f:SetHeight(borderWidth*2+ProximoGrid.db.profile.frame.padding*2+(ProximoGrid.db.profile.unitFrame.height+ProximoGrid.db.profile.frame.spacing)*ProximoGrid:GetColumns()-ProximoGrid.db.profile.frame.spacing);
	end
end

--Updates the uniframes.
function ProximoGrid:UpdateLayout()
	if (InCombatLockdown() == nil) then
		if ( not ProximoGrid:inArenaZone()) then
			for number, frame in pairs(ProximoGrid.UnitFrames) do
				ProximoGrid:UpdateFrameAttributes()
				frame:SetAttribute("unitID", nil);
				frame.unitID = nil;
				frame.unitName = nil;
				frame:SetAlpha(0);
				for unitID, opponent in pairs(ProximoGrid.Opponents) do
					ProximoGrid:AddUnit(unitID, opponent["unitName"], opponent["unitIsPet"])
				end
				if (number > ProximoGrid:GetRows()*ProximoGrid:GetColumns()) then
					frame:Hide();
				else
					frame:Show();
				end
			end
		end
	end
end


--Registers default events
function ProximoGrid:OnEnable()
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("PLAYER_REGEN_ENABLED");
	self:RegisterEvent("PLAYER_REGEN_DISABLED");
	self:RegisterEvent("ZONE_CHANGED_NEW_AREA");
	ProximoGrid.location = "Outside";
end

--Unregisters all events
function ProximoGrid:OnDisable()
	self:UnregisterAllEvents();

end

--Sets the x and y possition to 0 but keeps the anchor.
function ProximoGrid:ResetFramePosition()
	self.db.profile.frame.positionX = 0;
	self.db.profile.frame.positionY = 0;
	ProximoGrid:UpdateFramePosition();
end

--When the user stops moving the main frame
function ProximoGrid:StopMoveFrame()
	if (self.Frame["MainFrame"].isMoving) then
		self.Frame["MainFrame"]:StopMovingOrSizing()
		ProximoGrid:SaveFramePosition()
		self.Frame["MainFrame"].isMoving = false
	end
end

--Save the main frame's position
--The position is calculated based on cordinates where 0, 0 is the top left cordinate.
--To get the frame's position f:GetEffectiveScale() most be used as a multiplier.
--To get the frame's size f:GetEffectiveScale() must be used.
--To get the screens size UIParent:GetEffectiveScale() msut be used.
function ProximoGrid:SaveFramePosition()
	local anchor = ProximoGrid.db.profile.frame.anchor;
	local f = self.Frame["MainFrame"]
	local UIScale, UIWidth, UIHeight = UIParent:GetEffectiveScale(), UIParent:GetWidth(), UIParent:GetHeight();
	local MFScale, MFWidth, MFHeight, MFX, MFY  = f:GetEffectiveScale(), f:GetWidth(), f:GetHeight(), f:GetLeft(), f:GetTop();
	local x,y;
	if (anchor=="CENTER") then
		x = (MFX + MFWidth / 2) * MFScale - UIWidth / 2 * UIScale
		y = (MFY - MFHeight / 2) * MFScale - UIHeight / 2 * UIScale
	elseif (anchor=="LEFT") then
		x = (MFX) * MFScale
		y = (MFY - MFHeight / 2) * MFScale - UIHeight / 2 * UIScale
	elseif (anchor=="RIGHT") then
		x = -(UIWidth * UIScale-(MFX + MFWidth) * MFScale)
		y = (MFY - MFHeight / 2) * MFScale - UIHeight / 2 * UIScale
	elseif (anchor=="TOP") then
		x = (MFX + MFWidth / 2) * MFScale - UIWidth / 2 * UIScale
		y = (MFY) * MFScale - UIHeight * UIScale
	elseif (anchor=="BOTTOM") then
		x = (MFX + MFWidth / 2) * MFScale - UIWidth / 2 * UIScale
		y = (MFY-MFHeight) * MFScale
	elseif (anchor=="TOPLEFT") then
		x = (MFX) * MFScale
		y = (MFY) * MFScale - UIHeight * UIScale
	elseif (anchor=="BOTTOMLEFT") then
		x = (MFX) * MFScale
		y = (MFY-MFHeight) * MFScale
	elseif (anchor=="BOTTOMRIGHT") then
		x = -(UIWidth * UIScale-(MFX + MFWidth) * MFScale)
		y = (MFY-MFHeight) * MFScale
	elseif (anchor=="TOPRIGHT") then
		x = -(UIWidth * UIScale-(MFX + MFWidth) * MFScale)
		y = (MFY) * MFScale - UIHeight * UIScale
	end
	self.db.profile.frame.positionX = x;
	self.db.profile.frame.positionY = y;
end

--When the user starts moving the main frame
function ProximoGrid:StartMoveFrame()
	if not self.db.profile.frame.lock and arg1 == "LeftButton" then
		self.Frame["MainFrame"]:StartMoving()
		self.Frame["MainFrame"].isMoving = true
	end
end

--Adds options for a status
function ProximoGrid:UpdateStatusOptions(name, header, options)
	ProximoGrid.options.args.Status.args[name] = {
		type = "group",
		name = header,
		desc = "Configure "..header,
		args = options
	};
end

--Updates announcement options
function ProximoGrid:UpdateAnnouncementOptions()
	local announceOptions = ProximoGrid.options.args.announcements.args;
	announceOptions.moreSettings.args = {};
	for name, data in pairs (ProximoGrid.db.profile.announcements) do
		announceOptions[name] = {
			type = "group",
			name = name,
			desc = string.format(L["Options for %s."], name),
			order = 20,
			args = {}
		}
		for announcementName, announcementData in pairs(ProximoGrid.RegisteredAnnouncement) do
			announceOptions[name].args[announcementName] = {
				type = "toggle",
				name = announcementData.name,
				desc = string.format(L["Toggle %s."], announcementData.name),
				get = function()
					return (data[announcementName]~=nil and data[announcementName]);
				end,
				set = function(v)
					data[announcementName] = v;
					if (not v and ProximoGrid.profileDefault.announcements[name][announcementName] == nil) then
						data[announcementName] = nil;
					end
				end
			}
		end
	end
	for announcementName, announcementData in pairs(ProximoGrid.RegisteredAnnouncement) do
		local settings = ProximoGrid.db.profile.status[announcementData.statusModule.name].db.announcements;
		if (settings[announcementName] == nil) then
			settings[announcementName] = {};
		end
		announceOptions.moreSettings.args[announcementName] = {
			type = "group",
			name = announcementData.name,
			desc = string.format(L["Options for %s."], announcementData.name),
			order = 100,
			args = {
				color = {
					type = 'color',
					name = L["Color"],
					desc = L["Color."],
					get = function()
						local tmpColor
						if (settings[announcementName] == nil or settings[announcementName].color == nil) then
							tmpColor = {1, 0, 0, 1}
						else
							tmpColor = settings[announcementName].color;
						end
						return tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4]
					end,
					set = function(r, g, b, a)
						if (settings[announcementName] == nil) then
							settings[announcementName] = {}
						end
						if (settings[announcementName].color == nil) then
							settings[announcementName].color = {};
						end
						local tmpColor = settings[announcementName].color;
						tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4] = r, g, b, a or 1
					end,
					hasAlpha = false,
					order = 20
				},
				selectSound = {
					type = "text",
					name = L["Select Sound"],
					desc = L["Select which sound to play if 'Enable Sound Warning' is turned on."],
					get = function ()
						if (settings[announcementName].soundFile == nil) then
							return "Levelup";
						else
							return settings[announcementName].soundFile;
						end
					end,
					set = function (v)
						settings[announcementName].soundFile = v;
					end,
					validate=media:List("sound"),
					order = 60,
				},
				playSound = {
					type = "execute",
					name = L["Play Sound"],
					desc = L["Play the selected sound."],
					order = 106,
					func = function()
						if (settings[announcementName].soundFile == nil) then
							PlaySoundFile(media:Fetch("sound", "Levelup"));
						else
							PlaySoundFile(media:Fetch("sound", settings[announcementName].soundFile));
						end
					end,
					order = 80
				}
			}
		}

	end
	
	
end

--Updates indicator options
function ProximoGrid:UpdateIndicatorOptions()
	local indiOptions = ProximoGrid.options.args.Frame.args;
	for name, data in pairs(ProximoGrid.db.profile.indicators) do
		if (data["name"]~=nil) then
			local indiStatus = data.status;
			for statusName, statusData in pairs(ProximoGrid.RegisteredStatus) do
				indiOptions[name].args[statusName] = {
					type = 'toggle',
					name = statusData["name"],
					desc = L["Toggle status display"],
					get = function()
						return (indiStatus[statusName]~=nil and indiStatus[statusName]);
					end,
					set = function(v)
						indiStatus[statusName] = v;
						if (not v and ProximoGrid.profileDefault.indicators[name].status[statusName] == nil) then
							indiStatus[statusName] = nil;
						end
					end,
				}
			end
		end
	end
end

--Tries to find a spell id
function ProximoGrid:GetSpellID(spellName, spellRank)
	if (spellName == nil) then
		return nil;
	end
	if (spellRank == nil) then
		spellRank = "";
	end
	local link = GetSpellLink(spellName.."("..spellRank..")");
	if (link == nil) then
		return nil;
	end
	local _, _, _, spellID = string.find(link, "(%:)(%d*)");
	return spellID;
end

--Adds attributes for to a unitframe in a arena.
function ProximoGrid:AddArenaUnit(unitLink)
	local normalFrames;
	local frameNumber = tonumber(unitLink:sub(-1));
	local frame = ProximoGrid.UnitFrames[frameNumber];
	frame.unitID = unitLink;
	frame:SetAttribute("unit", unitLink);
	RegisterUnitWatch(frame, "true")
	frame:SetAlpha(1);
	frame:Hide();
end

--Adds and shows a unit in a bg
function ProximoGrid:AddUnit(unitID, unitName, unitIsPet)
	if (not unitIsPet or ProximoGrid.db.profile.frame.showPetFrame) then
		local normalFrames;
		if (ProximoGrid.db.profile.frame.showPetFrame) then
			normalFrames = (ProximoGrid:GetRows()/2)*ProximoGrid:GetColumns();
		else
			normalFrames = ProximoGrid:GetRows()*ProximoGrid:GetColumns();
		end
		for number, frame in pairs(ProximoGrid.UnitFrames) do
			if (not unitIsPet and number > normalFrames) then
				break;
			elseif(unitIsPet and number <= normalFrames) then
			else
				if (frame.unitID == nil) then
					frame.unitName = unitName;
					frame.unitID = unitID;
					frame:SetAlpha(1);
					for name, data in pairs (ProximoGrid.Indicators) do
						data.module:ResetIndicator(frame);
					end
					if (not InCombatLockdown()) then
						ProximoGrid:UpdateFrameAttributes()
						UnregisterUnitWatch(frame)
					end
					break;
				end
			end
		end
	end
end

--Updates auras
function ProximoGrid:UpdateAuras(unitLink)
	if (not ProximoGrid:inArenaZone() and  ProximoGrid.Opponents[UnitGUID(unitLink)] == nil or ProximoGrid:inArenaZone() and unitLink:sub(1,5) ~= "arena") then
		return
	end
	local unitID;
	if (ProximoGrid:inArenaZone()) then
		unitID = unitLink;
	else
		unitID = UnitGUID(unitLink);
	end
	if (ProximoGrid.Opponents[unitID] == nil) then
		return;
	end
	ProximoGrid.Opponents[unitID].unitAuras.debuffs = {};
	ProximoGrid.Opponents[unitID].unitAuras.buffs = {};
	if (unitLink ~= nil) then
		for i=1,40 do
			local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable =  UnitBuff(unitLink, i);
			if (name == nil) then
				break;
			end

			ProximoGrid.Opponents[unitID].unitAuras.buffs[name] = {
				["auraID"] = ProximoGrid:GetSpellID(name, rank),
				["auraIcon"] = icon,
				["auraDebuffType"] = debuffType,
				["auraName"] = name,
				["auraCount"] = count,
				["auraExpirationTime"] = expirationTime,
				["auraDuration"] = duration,
			};
		end
		for i=1,40 do
			local name, rank, icon, count, debuffType, duration, expirationTime, isMine, isStealable  =  UnitDebuff(unitLink, i);
			if (name == nil) then
				break;
			end
			ProximoGrid.Opponents[unitID].unitAuras.debuffs[name] = {
				["auraID"] = ProximoGrid:GetSpellID(name, rank),
				["auraIcon"] = icon,
				["auraDebuffType"] = debuffType,
				["auraName"] = name,
				["auraCount"] = count,
				["auraExpirationTime"] = expirationTime,
				["auraDuration"] = duration,
			};
		end
		ProximoGrid:EventDispatcher("PROXIMOGRID_UNIT_AURA_UPDATED", unitID);
	end
end

--Add an opponent to the list and setups standard values. Only used in an arena
function ProximoGrid:AddArenaOpponent(unitID)
	if (unitID:sub(1, 5) ~= "arena" or ProximoGrid.Opponents[unitID] ~= nil) then
		return
	end
	local unitName = UnitName(unitID);
	local unitClass = UnitClass(unitID);
	local unitRace = UnitRace(unitID);
	local unitSex = UnitSex(unitID);
	local unitIsPet = not UnitIsPlayer(unitID);
	local unitCreatureType = UnitCreatureType(unitID);
	local unitGUID = UnitCreatureType(unitID);
	if (unitName == nil or unitClass == nil or unitClass == "Unknown" or unitRace == nil or unitSex == nil or unitIsPet == nil or unitCreatureType == nil or unitGUID == nil) then
		return false;
	end
	
	ProximoGrid.Opponents[unitID] = {
		["unitName"] = unitName,
		["unitClass"] = unitClass,
		["unitRace"] = unitRace,
		["unitSex"] = unitSex,
		["unitIsPet"] = unitIsPet,
		["unitCreatureType"] = unitCreatureType,
		["unitGUID"] = unitGUID,
		["unitAuras"] = {
			["buffs"] = {},
			["debuffs"] = {}
		}
	};
	local frame = ProximoGrid:GetUnitFrameByUnitID(unitID);
	frame:SetAlpha(1);
	ProximoGrid:UpdateAuras(unitID);
	ProximoGrid:EventDispatcher("PROXIMOGRID_UNIT_ADDED", unitID);
end

--Add an opponent to the list and setups standard values. Only used in an bg
function ProximoGrid:AddOpponent(unitLink)
	local unitName = UnitName(unitLink);
	local unitClass = UnitClass(unitLink);
	local unitRace = UnitRace(unitLink);
	local unitSex = UnitSex(unitLink);
	local unitIsPet = not UnitIsPlayer(unitLink);
	local unitCreatureType = UnitCreatureType(unitLink);
	local unitGUID = UnitGUID(unitLink);
	if (unitGUID == nil or unitName == nil or unitCreatureType == "Totem" or unitCreatureType == "Non-combat Pet") then
		return
	end
	ProximoGrid.Opponents[unitGUID] = {
		["unitName"] = unitName,
		["unitClass"] = unitClass,
		["unitRace"] = unitRace,
		["unitSex"] = unitSex,
		["unitIsPet"] = unitIsPet,
		["unitCreatureType"] = unitCreatureType,
		["unitGUID"] = unitGUID,
		["unitLinks"] = {
			unitID
		},
		["unitAuras"] = {
			["buffs"] = {},
			["debuffs"] = {}
		}
	};
	ProximoGrid:UpdateAuras(unitLink);
	ProximoGrid:AddUnit(unitGUID, unitName, unitIsPet);
	ProximoGrid:EventDispatcher("PROXIMOGRID_UNIT_ADDED", unitGUID);
	ProximoGrid:UpdateOpponentHealth(unitLink);
	ProximoGrid:UpdateOpponentPower(unitLink);
end

function ProximoGrid:TestFunction()
	ProximoGrid:AddOpponent("player")
	--ProximoGrid.Opponents["player"] = ProximoGrid.Opponents[UnitGUID("player")];
	StatusCastingSpell:PROXIMOGRID_UNIT_SPELL_CASTING_START(UnitGUID("player"), "Flash Heal", false);
end


--Updates a unit's power (mana, energy etc.)
function ProximoGrid:UpdateOpponentPower(unitLink)
	local unitID;
	if (ProximoGrid:inArenaZone()) then
		unitID = unitLink;
		if (unitID:sub(1, 5) ~= "arena") then
			return
		end
		if (ProximoGrid.Opponents[unitID]==nil) then
			ProximoGrid:AddArenaOpponent(unitID);
		end
	else
		unitID = UnitGUID(unitLink);
	end
	if (ProximoGrid.Opponents[unitID]==nil) then
		return;
	end
	local unitPower = UnitPower(unitLink);
	local unitPowerMax = UnitPowerMax(unitLink);
	local unitPowerType = select(2, UnitPowerType(unitLink));
	local oldPower = ProximoGrid.Opponents[unitID]["unitPower"];
	local oldPowerMax = ProximoGrid.Opponents[unitID]["unitPowerMax"]
	local oldPowerType = ProximoGrid.Opponents[unitID]["unitPowerType"]
	ProximoGrid.Opponents[unitID]["unitPower"] = unitPower;
	ProximoGrid.Opponents[unitID]["unitPowerMax"] = unitPowerMax;
	ProximoGrid.Opponents[unitID]["unitPowerType"] = unitPowerType;
	if (oldPower ~= unitPower or oldPowerMax ~= unitPowerMax or oldPowerType ~= unitPowerType) then
		ProximoGrid:EventDispatcher("PROXIMOGRID_UNIT_POWER_UPDATED", unitID);
	end
end

--Updates an unit's health
function ProximoGrid:UpdateOpponentHealth(unitLink)
	local unitID;
	if (ProximoGrid:inArenaZone()) then
		unitID = unitLink;
		if (unitID:sub(1, 5) ~= "arena") then
			return
		end
		if (ProximoGrid.Opponents[unitID]==nil) then
			ProximoGrid:AddArenaOpponent(unitID);
		end
	else
		unitID = UnitGUID(unitLink);
	end
	if (ProximoGrid.Opponents[unitID]==nil) then
		return;
	end
	local unitHealth = UnitHealth(unitLink);
	local unitHealthMax = UnitHealthMax(unitLink);
	local oldHealth = ProximoGrid.Opponents[unitID]["unitHealth"];
	local oldHealthMax = ProximoGrid.Opponents[unitID]["unitHealthMax"];

	ProximoGrid.Opponents[unitID]["unitHealth"] = unitHealth;
	ProximoGrid.Opponents[unitID]["unitHealthMax"] = unitHealthMax;
	ProximoGrid:UpdateUnit(unitID);
	if (oldHealth ~= unitHealth or oldHealthMax ~= unitHealthMax) then
		ProximoGrid:EventDispatcher("PROXIMOGRID_UNIT_HEALTH_UPDATED", unitID);
	end
end

--Triggered when a unit starts casting a spell in an arena
function ProximoGrid:StartSpellCasting(unitID, spellName, channeled)
	if (unitID:sub(1, 5) ~= "arena") then
		return;
	end
	if (channeled == nil) then
		channeled = false;
	end
	ProximoGrid:EventDispatcher("PROXIMOGRID_UNIT_SPELL_CASTING_START", unitID, spellName, channeled);
end

--Triggered when a unit stops casting a spell in an arena
function ProximoGrid:StopSpellCasting(unitID, spellName)
	if (unitID:sub(1, 5) ~= "arena") then
		return;
	end
	ProximoGrid:EventDispatcher("PROXIMOGRID_UNIT_SPELL_CASTING_END", unitID, spellName);
end

--Triggered when a unit's spell is updated in an arena
function ProximoGrid:UpdateSpellCasting(unitID, spellName)
	if (unitID:sub(1, 5) ~= "arena") then
		return;
	end
	if (channeled == nil) then
		channeled = false;
	end
	ProximoGrid:EventDispatcher("PROXIMOGRID_UNIT_SPELL_CASTING_UPDATED", unitID, spellName, channeled);
end

--Add an aura, only used in bgs
function ProximoGrid:AddAura(unitGUID, auraId, buffOrDebuff, spellSchool)
	if (ProximoGrid.Opponents[unitGUID]==nil) then
		return;
	end
	local name, rank, icon = GetSpellInfo(auraId);
	ProximoGrid.Opponents[unitGUID].unitAuras[buffOrDebuff.."s"][name] = {
		["auraID"] = auraId,
		["auraIcon"] = icon,
		["auraSchool"] = spellSchool,
		["auraName"] = name
	}

	ProximoGrid:EventDispatcher("PROXIMOGRID_UNIT_AURA_ADDED", unitGUID, name, buffOrDebuff);
end

--Remove an aura, only used in bgs
function ProximoGrid:RemoveAura(unitGUID, auraId, buffOrDebuff)
	if (ProximoGrid.Opponents[unitGUID]==nil) then
		return;
	end
	local name = GetSpellInfo(auraId);
	if (ProximoGrid.Opponents[unitGUID] ~= nil) then
		if (buffOrDebuff == "debuff") then
			ProximoGrid.Opponents[unitGUID].unitAuras.debuffs[name] = nil
		else
			ProximoGrid.Opponents[unitGUID].unitAuras.buffs[name] = nil
		end
		ProximoGrid:EventDispatcher("PROXIMOGRID_UNIT_AURA_REMOVED", unitGUID, name, buffOrDebuff);
	end
end

--Updates the unit frame's background.
function ProximoGrid:UpdateUnit(unitID)
	local unitInfo = ProximoGrid.Opponents[unitID];
	local unitFrame = ProximoGrid:GetUnitFrameByUnitID(unitID);
	if (unitFrame ~= nil) then
		if (unitInfo["unitHealth"] > 0) then
			unitFrame.Bar:SetValue(unitInfo["unitHealth"]/unitInfo["unitHealthMax"]*100);
			local r, g, b;
			if (not unitInfo["unitIsPet"]) then
				r, g, b = ProximoGrid:GetColor("class", unitInfo.unitClass);
			else
				r, g, b = ProximoGrid:GetColor("creature type", unitInfo.unitCreatureType);
			end
			ProximoGrid.UnitFrame:SetBarColor(r, g, b, 1, unitFrame);
		else
			unitFrame.Bar:SetValue(100);
			ProximoGrid.UnitFrame:SetBarColor(1, 1, 1, 1, unitFrame);
		end
	end
end

--Gets a frame by it's ID
function ProximoGrid:GetUnitFrameByUnitID(unitID)
	for number, frame in pairs(ProximoGrid.UnitFrames) do
		if (frame.unitID ~= nil and frame.unitID == unitID) then
			return frame;
		end
	end
	return nil;
end

--Checks if the player is in a arena
function ProximoGrid:inArenaZone()
	if select(2, IsInInstance()) == "arena" then
		return true
	end
end

--Checks if the player is in a battle ground, except for AV
function ProximoGrid:inBGZone()
	if select(2,IsInInstance()) == "pvp" then
		if (GetRealZoneText() ~= L["Alterac Valley"]) then
			return true
		end
	end
end

--Update an indicator.
--If only the indicator is passed as a value then a test value is added for the test frame.
function ProximoGrid:UpdateIndicator(indicator, unitID, status)
	local frame = ProximoGrid:GetUnitFrameByUnitID(unitID);
	local cache;
	if (frame == nil) then
		cache = {
			priority = 90;
			range = 0;
			color = {	r = 1,
					g = 1, 
					b = 1, 
					a = 1
				};
			text = "Test Text";
			value = 50;
			maxValue = 100;
			texture = "Interface\\Icons\\INV_Misc_QuestionMark";
			start = GetTime();
			duration = 10;
			stack = 2;
			name = "Test";
		};
		frame = ProximoGrid.UnitFrames[unitID];
	else
		cache = ProximoGrid.StatusCache[unitID][status];
	end
	if (frame==nil) then
		return;
	end

	if (ProximoGrid.Indicators[indicator] ~= nil) then
		ProximoGrid.Indicators[indicator].module:SetIndicator(frame, cache.range, cache.color, cache.text,  cache.value, cache.maxValue, cache.texture, cache.start, cache.duration, cache.stack);
	end
end

--Resets and indicator to it's standard state
function ProximoGrid:ResetIndicator(indicator, unitID)
	--local cache = ProximoGrid.StatusCache[unitName][status];
	local frame = ProximoGrid:GetUnitFrameByUnitID(unitID);
	if (frame == nil) then
		frame = ProximoGrid.UnitFrames[unitID];
	end
	if (frame == nil) then
		return;
	end
	if (ProximoGrid.Indicators[indicator] ~= nil) then
		ProximoGrid.Indicators[indicator].module:ResetIndicator(frame);
	end
	
end

--Sends an announcement
function ProximoGrid:SendAnnouncement(msg, shortName)
	--if (not ProximoGrid.db.profile.announcement.enable or not ProximoGrid.db.profile.announcement.enableBG and ProximoGrid:inBGZone()) then 
	--	return;
	--end
	--Plays a sound file if sound announcement is enabled
	local settings = ProximoGrid.db.profile.status[ProximoGrid.RegisteredAnnouncement[shortName].statusModule.name].db.announcements[shortName];

	--Send the announcement in each channel it's enabled in
	for targetFrame, announcements in pairs (ProximoGrid.db.profile.announcements) do
		if (announcements[shortName] ~= nil and announcements[shortName]) then	
			local tmpColor
			
			if (settings ~= nil and settings.color ~= nil) then
				tmpColor = settings.color
			else
				tmpColor = {1, 0, 0, 1};
			end
			if (targetFrame == L["Scrolling Combat Text"]) then
				if SCT_Display then -- send via SCT if it exists
					SCT_Display(msg,{r=tmpColor[1],g=tmpColor[2],b=tmpColor[3]})
				elseif SHOW_COMBAT_TEXT=="1" then
					CombatText_AddMessage(msg, COMBAT_TEXT_SCROLL_FUNCTION, tmpColor[1], tmpColor[2], tmpColor[3]) -- or default UI's SCT
				else
					-- send vis UIErrorsFrame if neither SCT exists
					UIErrorsFrame:AddMessage(msg,tmpColor[1],tmpColor[2],tmpColor[3],1,UIERRORS_HOLD_TIME)
				end
			elseif(targetFrame == L["Chat"]) then
				DEFAULT_CHAT_FRAME:AddMessage(string.format("|c00%s%s%s%s", ProximoGrid:DecToHex(tmpColor[1]), ProximoGrid:DecToHex(tmpColor[2]), ProximoGrid:DecToHex(tmpColor[3]), msg));
			elseif(targetFrame == L["Party"]) then
				SendChatMessage(msg, "PARTY", GetDefaultLanguage("player"));
			elseif(targetFrame == L["Raid"]) then
				if (UnitInRaid("player")) then
					SendChatMessage(msg, "RAID", GetDefaultLanguage("player"));
				end
			elseif(targetFrame == L["Battleground"]) then
				SendChatMessage(msg, "BATTLEGROUND", GetDefaultLanguage("player"));
			elseif(targetFrame == L["Raid Warning"]) then
				if (IsRaidLeader() or IsRaidOfficer()) then
					SendChatMessage(msg, "RAID_WARNING", GetDefaultLanguage("player"));
				end
			elseif(targetFrame == L["Sound Warning"]) then
				if (ProximoGrid.db.profile.announcement.enableSound) then
					if (settings.soundFile ~= nil) then
						PlaySoundFile(media:Fetch("sound", settings.soundFile))
					else
						PlaySoundFile(media:Fetch("sound", "Levelup"));
					end
				end
			end
		end
	end

end

function ProximoGrid:DecToHex(number)
	local tmpNumber = math.floor(number*255);
	local tmpString = "";
	local tmpArray = "0123456789ABCDEF";
	for i=1, 2 do
		tmpString = tmpArray:sub(bit.band(tmpNumber, 15)+1, bit.band(tmpNumber, 15)+1) .. tmpString ;
		tmpNumber = bit.rshift(tmpNumber, 4)
	end
	return tmpString;
end

--Test function for combatlog flags
function ProximoGrid:TestFlags(flag)
	local flags = {
		["COMBATLOG_OBJECT_TYPE_MASK"] = 0,
		["COMBATLOG_OBJECT_TYPE_OBJECT"] = 0,
		["COMBATLOG_OBJECT_TYPE_GUARDIAN"] = 0,
		["COMBATLOG_OBJECT_TYPE_PET"] = 0,
		["COMBATLOG_OBJECT_TYPE_NPC"] = 0,
		["COMBATLOG_OBJECT_TYPE_PLAYER"] = 0,

		["COMBATLOG_OBJECT_CONTROL_MASK"] = 0,
		["COMBATLOG_OBJECT_CONTROL_NPC"] = 0,
		["COMBATLOG_OBJECT_CONTROL_PLAYER"] = 0,

		["COMBATLOG_OBJECT_REACTION_MASK"] = 0,
		["COMBATLOG_OBJECT_REACTION_HOSTILE"] = 0,
		["COMBATLOG_OBJECT_REACTION_NEUTRAL"] = 0,
		["COMBATLOG_OBJECT_REACTION_FRIENDLY"] = 0,

		["COMBATLOG_OBJECT_AFFILIATION_MASK"] = 0,
		["COMBATLOG_OBJECT_AFFILIATION_OUTSIDER"] = 0,
		["COMBATLOG_OBJECT_AFFILIATION_RAID"] = 0,
		["COMBATLOG_OBJECT_AFFILIATION_PARTY"] = 0,
		["COMBATLOG_OBJECT_AFFILIATION_MINE"] = 0,

		["COMBATLOG_OBJECT_SPECIAL_MASK"] = 0,
		["COMBATLOG_OBJECT_NONE"] = 0,
		["COMBATLOG_OBJECT_RAIDTARGET8"] = 0,
		["COMBATLOG_OBJECT_RAIDTARGET7"] = 0,
		["COMBATLOG_OBJECT_RAIDTARGET6"] = 0,
		["COMBATLOG_OBJECT_RAIDTARGET5"] = 0,
		["COMBATLOG_OBJECT_RAIDTARGET4"] = 0,
		["COMBATLOG_OBJECT_RAIDTARGET3"] = 0,
		["COMBATLOG_OBJECT_RAIDTARGET2"] = 0,
		["COMBATLOG_OBJECT_RAIDTARGET1"] = 0,
		["COMBATLOG_OBJECT_MAINASSIST"] = 0,
		["COMBATLOG_OBJECT_MAINTANK"] = 0,
		["COMBATLOG_OBJECT_FOCUS"] = 0,
		["COMBATLOG_OBJECT_TARGET"] = 0
	};
	DEFAULT_CHAT_FRAME:AddMessage("----------------");
	for current_flag, nothing in pairs(flags) do
		if (bit.band(flag, getglobal(current_flag))~=0) then
			DEFAULT_CHAT_FRAME:AddMessage(current_flag);
		end
	end
	DEFAULT_CHAT_FRAME:AddMessage("----------------");
end

function ProximoGrid:Debug(message)
	DEFAULT_CHAT_FRAME:AddMessage(message);
end

--Checks if an internal event is registered or not
function ProximoGrid:IsEventRegistered(event, func, class)
	if (ProximoGrid.RegistredEvents[event] == nil) then
		return false;
	end
	for k, v in pairs(ProximoGrid.RegistredEvents[event]) do
		if (v.class == class) then
			return true;
		end
	end
	return false;
end

--Registers an internal event
function ProximoGrid:RegisterProximoGridEvent(event, func, class)
	if (ProximoGrid.RegistredEvents[event] == nil) then
		ProximoGrid.RegistredEvents[event] = {};
		ProximoGrid.RegistredEventsCounter[event] = 0;
	end
	ProximoGrid.RegistredEvents[event][ProximoGrid.RegistredEventsCounter[event]] = {
		["func"] = func,
		["class"] = class
	}
	ProximoGrid.RegistredEventsCounter[event] = ProximoGrid.RegistredEventsCounter[event] + 1;
end

--Unregisterns an internal event
function ProximoGrid:UnregisterProximoGridEvent(event, class)
	local counter = 1;
	if (ProximoGrid.RegistredEvents[event] == nil) then
		return;
	end
	for k, v in pairs(ProximoGrid.RegistredEvents[event]) do
		counter = counter + 1;
		if (v.class == class) then
			ProximoGrid.RegistredEvents[event][k] = nil;
			counter = counter - 1;
			break;
		end
	end
	if (counter == 0) then
		ProximoGrid.RegistredEvents[event] = nil;
	end
end

--Sends an event to all registered functions
function ProximoGrid:EventDispatcher(event, ...) 
	if (ProximoGrid.RegistredEvents[event] ~= nil) then
		for number, func in pairs (ProximoGrid.RegistredEvents[event]) do
			func["func"](func["class"], event, ...);
		end
	end
end



function ProximoGrid:UNIT_TARGET(unitID)
	ProximoGrid:UpdateUnitLink(unitID.."target");
end

function ProximoGrid:UPDATE_MOUSEOVER_UNIT()
	ProximoGrid:UpdateUnitLink("mouseover")
end

function ProximoGrid:PLAYER_REGEN_DISABLED()
	ProximoGrid.options.args.Layout.disabled = true;
	ProximoGrid.options.args.Frame.disabled = true;
	ProximoGrid.options.args.macros.disabled = true;
	waterfall:Refresh("ProximoGrid")
end

--Makes sure that all unitframes attributes are right when leaving combat.
function ProximoGrid:PLAYER_REGEN_ENABLED()
	ProximoGrid.options.args.Layout.disabled = false;
	ProximoGrid.options.args.Frame.disabled = false;
	ProximoGrid.options.args.macros.disabled = false;
	waterfall:Refresh("ProximoGrid");
	if (ProximoGrid.location == "BG" or ProximoGrid.location == "Arena") then
		for number, frame in pairs(ProximoGrid.UnitFrames) do
			ProximoGrid:UpdateFrameAttributes();
		end
	end
end


function ProximoGrid:UpdateFrameAttributes()
	if (not InCombatLockdown()) then
		for frameNumber, frame in pairs(ProximoGrid.UnitFrames) do
			if (ProximoGrid.location == "BG") then
				for number, buttonInfo in pairs (ProximoGrid.db.profile.macros) do
					if (frame.unitName ~= nil) then
						if (buttonInfo.actionType == "target") then
							frame:SetAttribute("type1", "macro");
							frame:SetAttribute("macrotext"..number, "/targetexact "..frame.unitName);
						elseif (buttonInfo.actionType == "spell") then
							frame:SetAttribute("type"..number, "macro");
							frame:SetAttribute("macrotext"..number, "/targetexact "..frame.unitName.."\n/cast "..buttonInfo.action.."\n/targetlasttarget");
						elseif (buttonInfo.actionType == "macro") then
							frame:SetAttribute("type"..number, "macro");
							frame:SetAttribute("macro"..number, GetMacroIndexByName(buttonInfo.action));
						elseif (buttonInfo.actionType == "macroText") then
							frame:SetAttribute("type"..number, "macro");
							frame:SetAttribute("macrotext"..number, buttonInfo.action);
						end
					end
				end
			elseif(ProximoGrid.location == "Arena") then
				for number, buttonInfo in pairs (ProximoGrid.db.profile.macros) do
					if (buttonInfo.actionType == "target") then
						frame:SetAttribute("type"..number, "target");
					elseif (buttonInfo.actionType == "spell") then
						frame:SetAttribute("type"..number, "spell");
						frame:SetAttribute("spell"..number, buttonInfo.action);
					elseif (buttonInfo.actionType == "macro") then
						frame:SetAttribute("type"..number, "macro");
						frame:SetAttribute("macro"..number, GetMacroIndexByName(buttonInfo.action));
					elseif (buttonInfo.actionType == "macroText") then
						frame:SetAttribute("type"..number, "macro");
						frame:SetAttribute("macrotext"..number, buttonInfo.action);
					end
				end
			else
			
			end
		end
	end
end

function ProximoGrid:ZONE_CHANGED_NEW_AREA()
	ProximoGrid:UpdateFrame();
end


function ProximoGrid:PLAYER_ENTERING_WORLD()
	ProximoGrid:UpdateFrame();	
end

--Inits all events and resets all tables depending on what zone the player has entered.
function ProximoGrid:UpdateFrame()
	--Events that should be registered
	local arenaEventList = {"UNIT_AURA", "UNIT_HEALTH", "UNIT_MANA", "UNIT_RAGE", "UNIT_ENERGY", "UNIT_FOCUS", "UNIT_MAXHEALTH", "UNIT_MAXMANA",
				"UNIT_MAXRAGE", "UNIT_MAXENERGY", "UNIT_MAXFOCUS",  "UNIT_DISPLAYPOWER",  "UPDATE_WORLD_STATES",
				"UNIT_SPELLCAST_START", "UNIT_SPELLCAST_STOP", "UNIT_SPELLCAST_DELAYED", 
				"UNIT_SPELLCAST_FAILED", "UNIT_SPELLCAST_INTERRUPTED", "UNIT_SPELLCAST_CHANNEL_START", "UNIT_SPELLCAST_CHANNEL_UPDATE", "UNIT_SPELLCAST_CHANNEL_STOP"};
	local bgEventList = {"COMBAT_LOG_EVENT_UNFILTERED", "UNIT_TARGET", "UPDATE_MOUSEOVER_UNIT", "UPDATE_BATTLEFIELD_SCORE"};
	--Clear all old data and reset the frame
	ProximoGrid.Opponents = {};
	ProximoGrid.StatusCache = {};
	ProximoGrid.arenaSize = 2;
	ProximoGrid:UpdateLayout();
	ProximoGrid:UpdateFrameSize();
	ProximoGrid:UpdateFramePosition();
	ProximoGrid.Frame["MainFrame"]:SetScript("OnUpdate", nil);
	--Unregister all old events
	--if (ProximoGrid.location=="Arena") then
	for number, event in pairs (arenaEventList) do
		ProximoGrid:RegisterEvent(event);
	end
	--elseif(ProximoGrid.location=="BG") then
	for number, event in pairs (bgEventList) do
		ProximoGrid:RegisterEvent(event);
	end
	--end

	for number, uf in pairs(ProximoGrid.UnitFrames) do
		uf.Bar:SetValue(100);
		uf.BarBG:SetVertexColor(1, 1, 1);
		if (number > ProximoGrid:GetRows() * ProximoGrid:GetColumns()) then
			uf:Hide();
		else
			uf:Show();
		end
		for name, data in pairs(ProximoGrid.db.profile.indicators) do
			ProximoGrid:ResetIndicator(name, number);
		end
	end
	
	--Init all arena specific stuff
	if (ProximoGrid:inArenaZone()) then
		for number, event in pairs (bgEventList) do
			ProximoGrid:UnregisterEvent(event);
		end
		for name, status in pairs(ProximoGrid.profileDefault.status) do
			getglobal(status["name"]):Enable(true);
		end
		for i=1, 5 do
			ProximoGrid:AddArenaUnit("arena"..i);
		end
		ProximoGrid:UpdateFrameAttributes();
		ProximoGrid.Frame["MainFrame"]:SetScript("OnUpdate", ProximoGrid.OnArenaUpdate);
		ProximoGrid.location = "Arena";
		ProximoGrid.Frame["MainFrame"]:Show();
		--Init all bg specific stuff
	elseif (ProximoGrid:inBGZone() and ProximoGrid.db.profile.frame.useInBG) then
		for number, event in pairs (arenaEventList) do
			self:UnregisterEvent(event);
		end
		ProximoGrid.Frame["MainFrame"]:SetScript("OnUpdate", ProximoGrid.OnUpdate);
		for name, status in pairs(ProximoGrid.profileDefault.status) do
			getglobal(status["name"]):Enable(true);
		end
		ProximoGrid.location = "BG";
		ProximoGrid.Frame["MainFrame"]:Show();
	else
		local tmpArray = {};
		for number, event in pairs (bgEventList) do
			tmpArray[event] = false;
			ProximoGrid:UnregisterEvent(event);
		end
		for number, event in pairs (arenaEventList) do
			if (tmpArray[event]==nil) then
				self:UnregisterEvent(event);
			end
		end
		for number, uf in pairs(ProximoGrid.UnitFrames) do
			uf:Hide();
		end
		for name, status in pairs(ProximoGrid.profileDefault.status) do
			getglobal(status["name"]):Enable(false);
		end
		if (ProximoGrid.db.profile.frame.lock) then
			ProximoGrid.Frame["MainFrame"]:Hide();
		end	
		ProximoGrid.location = "Outside";
	
	end
	

	
end

--Update functions for arena
function ProximoGrid:UNIT_MANA(unitID)
	self:UpdateOpponentPower(unitID);
end

function ProximoGrid:UNIT_FOCUS(unitID)
	self:UpdateOpponentPower(unitID);
end

function ProximoGrid:UNIT_RAGE(unitID)
	self:UpdateOpponentPower(unitID);
end

function ProximoGrid:UNIT_ENERGY(unitID)
	self:UpdateOpponentPower(unitID);
end

function ProximoGrid:UNIT_HEALTH(unitID)
	self:UpdateOpponentHealth(unitID);
end

function ProximoGrid:UNIT_MAXMANA(unitID)
	self:UpdateOpponentPower(unitID);
end

function ProximoGrid:UNIT_MAXFOCUS(unitID)
	self:UpdateOpponentPower(unitID);
end

function ProximoGrid:UNIT_MAXRAGE(unitID)
	self:UpdateOpponentPower(unitID);
end

function ProximoGrid:UNIT_MAXENERGY(unitID)
	self:UpdateOpponentPower(unitID);
end

function ProximoGrid:UNIT_MAXHEALTH(unitID)
	self:UpdateOpponentHealth(unitID);
end

function ProximoGrid:UNIT_DISPLAYPOWER(unitID)
	self:UpdateOpponentPower(unitID);
end

function ProximoGrid:UNIT_AURA(unitID)
	self:UpdateAuras(unitID);
end

function ProximoGrid:UNIT_SPELLCAST_START(unitID, spellName)
	self:StartSpellCasting(unitID, spellName, false);
end

function ProximoGrid:UNIT_SPELLCAST_STOP(unitID, spellName)
	self:StopSpellCasting(unitID, spellName, false);
end

function ProximoGrid:UNIT_SPELLCAST_DELAYED(unitID, spellName)
	self:UpdateSpellCasting(unitID, spellName, false);
end

function ProximoGrid:UNIT_SPELLCAST_FAILED(unitID, spellName)
	self:StopSpellCasting(unitID, spellName, false);
end

function ProximoGrid:UNIT_SPELLCAST_INTERRUPTED(unitID, spellName)
	self:StopSpellCasting(unitID, spellName, false);
end

function ProximoGrid:UNIT_SPELLCAST_CHANNEL_START(unitID, spellName)
	self:StartSpellCasting(unitID, spellName, true);
end

function ProximoGrid:UNIT_SPELLCAST_CHANNEL_UPDATE(unitID, spellName)
	self:UpdateSpellCasting(unitID, spellName, true)
end

function ProximoGrid:UNIT_SPELLCAST_CHANNEL_STOP(unitID, spellName)
	self:StopSpellCasting(unitID, spellName, true);
end

--Checks for how many players there are currently in the arena.
function ProximoGrid:UPDATE_WORLD_STATES()
	local uiType, state, text;
	for i=1, 2 do
		uiType, state, text = GetWorldStateUIInfo(i);
		if (text ~= nil) then
			local tmpNumber = tonumber(text:sub(text:find("%d")));
			if (tmpNumber>ProximoGrid.arenaSize) then
				ProximoGrid.arenaSize = tmpNumber;	
			end
		end
	end
end

--Checks the leader board in a bg for players and removes players from the frame that were not found on the leader board.
function ProximoGrid:UPDATE_BATTLEFIELD_SCORE()
	local numScores = GetNumBattlefieldScores()
	local minNumber = 0;
	--The minimum players that the leader board must have before ProximoGrid will start to remove an units.
	--This is to make sure the leader board is loaded.
	if (GetRealZoneText() == L["Warsong Gulch"]) then
		minNumber = 8;
	elseif (GetRealZoneText() == L["Arathi Basin"]) then
		minNumber = 12;
	elseif (GetRealZoneText() == L["Eye of the Storm"]) then
		minNumber = 12;
	elseif (GetRealZoneText() == L["Strand of the Ancients"]) then
		minNumber = 12;
	end

	if (minNumber == 0 or numScores<minNumber) then
		return;
	end

	local tmpUnits = {};
	for k, v in pairs(ProximoGrid.UnitFrames) do
		if (v.unitID~=nil) then
			tmpUnits[v.unitName] = v.unitID;
		end
	end
	--Saves all the enemies into a temp table
	for i=1, numScores do
		local name, killingBlows, honorableKills, deaths, honorGained, faction, rank, race, class = GetBattlefieldScore(i);
		if ( faction and faction ~= ProximoGrid.faction) then
			local tmpSplitPos = string.find(name, "-");
			if (tmpSplitPos ~=nil)then
				name = string.sub(name, 1, tmpSplitPos-1);
			end
			if (tmpUnits[name] ~= nil) then
				tmpUnits[name] = nil;
			end
		end
	end
	--Removes all unwanted units from the frame.
	for k, v in pairs(tmpUnits) do
		ProximoGrid.Opponents[v] = nil;
		ProximoGrid.StatusCache[v] = nil;
		local uf = ProximoGrid:GetUnitFrameByUnitID(v);
		uf.unitID = nil;
		uf.unitName = nil;
		uf:SetAlpha(0);
		if (not InCombatLockdown()) then
			uf:SetAttribute("macrotext1", "");
		end
	end

end

--Combat log events
function ProximoGrid:COMBAT_LOG_EVENT_UNFILTERED(arg1, combatevent, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellId, spellName, spellSchool, missType, extraSpellName, extraSchool, auraType)
	--SPELL_AURA_APPLIED
	if (combatevent == "SPELL_AURA_APPLIED" and bit.band(COMBATLOG_OBJECT_CONTROL_PLAYER, destFlags) ~= 0 and bit.band(COMBATLOG_OBJECT_AFFILIATION_OUTSIDER, destFlags) ~= 0  and (bit.band(COMBATLOG_OBJECT_REACTION_HOSTILE, destFlags) ~= 0 )) then
		
		ProximoGrid:AddAura(destGUID, spellId, string.lower(missType), spellSchool);
	elseif (	combatevent == "SPELL_AURA_REMOVED" or 
			combatevent == "SPELL_AURA_DISPELLED"  or
			combatevent == "SPELL_AURA_BROKEN"  or
			combatevent == "SPELL_AURA_STOLEN") then
			if (false) then
				ProximoGrid:RemoveAura(destGUID, spellId, missType)
			end
	elseif ( (combatevent == "UNIT_DIED" or combatevent == "UNIT_DESTROYED") and bit.band(COMBATLOG_OBJECT_TYPE_PET, destFlags)~=0 and bit.band(COMBATLOG_OBJECT_REACTION_HOSTILE, destFlags)~=0) then
		ProximoGrid.UnitFrames[destGUID] = nil;
		--ProximoGrid:UpdateLayout();
	elseif ((combatevent == "UNIT_DIED" or combatevent == "UNIT_DESTROYED") and bit.band(COMBATLOG_OBJECT_REACTION_HOSTILE, destFlags)~=0) then
		if (false and ProximoGrid.Opponents[destGUID] ~=nil) then
			ProximoGrid.Opponents[destGUID].unitAuras.buffs = {};
			ProximoGrid.Opponents[destGUID].unitAuras.debuffs = {};
			ProximoGrid.Opponents[destGUID].unitHealth = 0;
			ProximoGrid.Opponents[destGUID].unitPower = 0;
			ProximoGrid:UpdateAuras(destGUID);
			ProximoGrid:UpdateUnit(destGUID);
			ProximoGrid:EventDispatcher("PROXIMOGRID_UNIT_DIED", destGUID);
		end
	end
	
end

--Updates the list of unitID's that is know to work as a link to an opponent.
--If the opponent has not been seen before add it to the list.
function ProximoGrid:UpdateUnitLink(unitLink)
	local testedUnits = {};

	if (UnitExists(unitLink) and UnitCanAttack("player", unitLink) and UnitPlayerControlled(unitLink) and UnitIsPlayer(unitLink)) then
		local unitGUID = UnitGUID(unitLink);
		if (unitGUID ~= nil) then
			if (ProximoGrid.Opponents[unitGUID] == nil) then
				ProximoGrid:AddOpponent(unitLink);
			else
				ProximoGrid:UpdateAuras(unitLink);
			end
			if (ProximoGrid:GetUnitFrameByUnitID(unitGUID) ~= nil) then
				ProximoGrid.Opponents[unitGUID].unitLinks[unitLink] = true;
			end
			
		end
		
	end

end


ProximoGrid.lastUpdate = GetTime();
--The OnUpdate function. 
function ProximoGrid:OnUpdate(selfh, elapsed)
	for i=1, ProximoGrid:GetRows()*ProximoGrid:GetColumns() do
		local uf = ProximoGrid.UnitFrames[i];
		if (uf.unitID ~= nil) then
			for k, v in pairs (ProximoGrid.Opponents[uf.unitID].unitLinks) do

				if ((ProximoGrid:inArenaZone() and UnitGUID(k) == UnitGUID(uf.unitID)) or UnitGUID(k) == uf.unitID) then
					ProximoGrid:UpdateOpponentPower(k);
					ProximoGrid:UpdateOpponentHealth(k);
					break;
				else
					ProximoGrid.Opponents[uf.unitID].unitLinks[k] = nil;
				end
			end
		end
	end
	if (GetTime() - ProximoGrid.lastUpdate > 10) then
		RequestBattlefieldScoreData();
		ProximoGrid.lastUpdate = GetTime();
	end
end

function ProximoGrid:OnArenaUpdate(selfh, elapsed)
	if (GetTime() - ProximoGrid.lastUpdate > 0.3) then
		local counter = 0;
		for i=1, 5 do
			if (UnitName("arena"..i)~=nil and UnitName("arena"..i)~="Unknown") then
				ProximoGrid:UpdateOpponentPower("arena"..i);
				ProximoGrid:UpdateOpponentHealth("arena"..i);
				counter = counter + 1;
			end
		end
		ProximoGrid.lastUpdate = GetTime();
		if (ProximoGrid.arenaSize == counter) then
			ProximoGrid.Frame["MainFrame"]:SetScript("OnUpdate", nil);
		end
	end
end

--Returns color depending on class, race, creature type or power type
function ProximoGrid:GetColor(group, type)
	--local type = string.upper(class);
	local group = string.lower(group);
	local colorDB = ProximoGrid.db.profile.colors;
	local r,g,b,a;
	if (group == "class") then
		if (colorDB.class[type] ~= nil) then
			r,g,b,a = colorDB.class[type][1], colorDB.class[type][2], colorDB.class[type][3], colorDB.class[type][4];
		else
			r,g,b,a = colorDB.fallback["Unknown Unit"][1], colorDB.fallback["Unknown Unit"][2], colorDB.fallback["Unknown Unit"][3], colorDB.fallback["Unknown Unit"][4];
		end
	elseif (group == "race") then
		if (colorDB.race[type] ~= nil) then
			r,g,b,a = colorDB.race[type][1], colorDB.race[type][2], colorDB.race[type][3], colorDB.race[type][4];
		else
			r,g,b,a = colorDB.fallback["Unknown Unit"][1], colorDB.fallback["Unknown Unit"][2], colorDB.fallback["Unknown Unit"][3], colorDB.fallback["Unknown Unit"][4];
		end
	elseif (group == "creature type") then
		if (colorDB.creatureType[type] ~= nil) then
			r,g,b,a = colorDB.creatureType[type][1], colorDB.creatureType[type][2], colorDB.creatureType[type][3], colorDB.creatureType[type][4];
		else
			r,g,b,a = colorDB.fallback["Unknown Unit"][1], colorDB.fallback["Unknown Unit"][2], colorDB.fallback["Unknown Unit"][3], colorDB.fallback["Unknown Unit"][4];
		end
	elseif (group == "power type") then
		--if (colorDB.creatureType[type] ~= nil) then
		if (colorDB.powerType[type] == nil) then
			r,g,b,a = {1, 1, 1, 1};
		else
			
			r,g,b,a = colorDB.powerType[type][1], colorDB.powerType[type][2], colorDB.powerType[type][3], colorDB.powerType[type][4];
		end
		--else
		--	r,g,b,a = colorDB.fallback["Unknown Unit"][1], colorDB.fallback["Unknown Unit"][2], colorDB.fallback["Unknown Unit"][3], colorDB.fallback["Unknown Unit"][4];
		--end
	end
	return r,g,b,a;
end